//
// ContactListingNotes.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct ContactListingNotes: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var contactKeyNumeric: Double?
    public var contactListingNotesKeyNumeric: Double?
    public var listingKeyNumeric: Double?
    public var contactKey: String?
    public var contactListingNotesKey: String?
    public var listingId: String?
    public var listingKey: String?
    public var noteContents: String?
    public var notedBy: String?
    public var modificationTimestamp: Date?
    public var contact: Contacts?

    public init(id: Int? = nil, contactKeyNumeric: Double? = nil, contactListingNotesKeyNumeric: Double? = nil, listingKeyNumeric: Double? = nil, contactKey: String? = nil, contactListingNotesKey: String? = nil, listingId: String? = nil, listingKey: String? = nil, noteContents: String? = nil, notedBy: String? = nil, modificationTimestamp: Date? = nil, contact: Contacts? = nil) {
        self.id = id
        self.contactKeyNumeric = contactKeyNumeric
        self.contactListingNotesKeyNumeric = contactListingNotesKeyNumeric
        self.listingKeyNumeric = listingKeyNumeric
        self.contactKey = contactKey
        self.contactListingNotesKey = contactListingNotesKey
        self.listingId = listingId
        self.listingKey = listingKey
        self.noteContents = noteContents
        self.notedBy = notedBy
        self.modificationTimestamp = modificationTimestamp
        self.contact = contact
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case contactKeyNumeric = "ContactKeyNumeric"
        case contactListingNotesKeyNumeric = "ContactListingNotesKeyNumeric"
        case listingKeyNumeric = "ListingKeyNumeric"
        case contactKey = "ContactKey"
        case contactListingNotesKey = "ContactListingNotesKey"
        case listingId = "ListingId"
        case listingKey = "ListingKey"
        case noteContents = "NoteContents"
        case notedBy = "NotedBy"
        case modificationTimestamp = "ModificationTimestamp"
        case contact = "Contact"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(contactKeyNumeric, forKey: .contactKeyNumeric)
        try container.encodeIfPresent(contactListingNotesKeyNumeric, forKey: .contactListingNotesKeyNumeric)
        try container.encodeIfPresent(listingKeyNumeric, forKey: .listingKeyNumeric)
        try container.encodeIfPresent(contactKey, forKey: .contactKey)
        try container.encodeIfPresent(contactListingNotesKey, forKey: .contactListingNotesKey)
        try container.encodeIfPresent(listingId, forKey: .listingId)
        try container.encodeIfPresent(listingKey, forKey: .listingKey)
        try container.encodeIfPresent(noteContents, forKey: .noteContents)
        try container.encodeIfPresent(notedBy, forKey: .notedBy)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(contact, forKey: .contact)
    }
}

